﻿namespace BPA.MES.Base.Application.Services
{
    /// <summary>
    /// 名    称 ：产线管理  
    /// 创 建 人 ：yangxiao  
    /// 创建时间 ：  2023/7/18 14:03:27 
    /// 描    述 ：  
    /// </summary>
    public class CraftsStepsDto
    {
        /// <summary>
        /// 步骤Id
        /// </summary>
        public string CraftId { get; set; }
        /// <summary>
        /// 步骤
        /// </summary>
        public int Step { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 单位
        /// </summary>
        public string Unit { get; set; }
        /// <summary>
        /// 功能参数
        /// </summary>
        public string Value { get; set; }
        /// <summary>
        /// 功能值 物料信息
        /// </summary>
        public string Materials { get; set; }
        /// <summary>
        /// 功能描述
        /// </summary>
        public string Describe { get; set; }
    }
    /// <summary>
    /// 增加
    /// </summary>
    public class CraftsStepsAddInput : CraftsStepsDto
    {

    }
    /// <summary>
    /// 更新
    /// </summary>
    public class CraftsStepsUpdateInput : CraftsStepsDto
    {
        /// <summary>
        /// 主键
        /// </summary>
        public string Id { get; set; }
    }
    /// <summary>
    /// 删除
    /// </summary>
    public class CraftsStepsDelInput
    {
        /// <summary>
        /// 主键
        /// </summary>
        public string Id { get; set; }
    }
    /// <summary>
    /// 分页
    /// </summary>
    public class CraftsStepsQueryPageInput : RequestPage
    {
        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 编码
        /// </summary>
        public string Code { get; set; }
        /// <summary>
        /// 工艺Id
        /// </summary>
        public string CraftId { get; set; }
    }
    /// <summary>
    /// 输出
    /// </summary>
    public class CraftsStepsOutput : CraftsStepsDto
    {
        /// <summary>
        /// 主键
        /// </summary>
        public string Id { get; set; }
    }
}
