/* eslint-disable array-callback-return */
/**
 * 工艺信息管理
 * @param Page
 * @returns
 */
import { ActionType, BetaSchemaForm, DragSortTable, EditableFormInstance, EditableProTable, ProCard, ProColumns, ProForm } from '@ant-design/pro-components';
import { ProTable } from '@ant-design/pro-components';
import { Button, Modal, Form, Input, message, Popconfirm, Spin, Tag, Space, Select, Card, Col, Row } from 'antd';
import { useEffect, useRef, useState } from 'react';
import CraftsInfoAPI from '@/api/craftsinfo'
import MaterialsInfoAPI from '@/api/materialService'
import DeviceInfoAPI from '@/api/DeviceInfo'
import DeviceProductAPI from '@/api/deviceInfo/services/deviceProduct';
import './index.less'


const Index = () => {
  //表单
  const [typeForm] = Form.useForm();
  //编辑/新增弹窗
  const [isModalOpen, setIsModalOpen] = useState(false);
  const [spinStatus, setSpinStatus] = useState(false);
  const [isSchemaModalOpen, setIsSchemaModalOpen] = useState(false);
  const [isSetpModalOpen, setIsSetpModalOpen] = useState(false);
  const [devices, setDevices] = useState<any>([]);
  const [deviceProducts, setDevicesProducts] = useState<any>([]);
  const [stepparams, setStepparams] = useState<any>();
  const [stepTitle, setStepTitle] = useState<any>('步骤列表');
  const [rowIndex, setRowIndex] = useState<any>();
  const [selectRowItem, setSelectRowItem] = useState<any>();
  const [materiallist, setMateriallist] = useState<RecipeMaterialTypes.Info[]>([]);
  const [selectMateriallist, setSelectMateriallist] = useState<RecipeMaterialTypes.Info[]>([]);

  const [deviceParm, setDeviceParm] = useState<any>([]);


  const actionRef = useRef<ActionType>();
  const [formRef] = Form.useForm();
  const sortActionRef = useRef<ActionType>();
  const editactionRef = useRef<ActionType>();


  useEffect(() => {
    DeviceInfoAPI.selectlist().then((res: MyResponse.Content) => {
      // 设备的数组
      if (res.statusCode === 200) {
        setDevices(res.data)
      }
    })

    DeviceProductAPI.SelectList().then((res:MyResponse.Content)=>{
      if (res.statusCode===200) {
        setDevicesProducts(res.data)
      }
    })
  }, [])





  //方法
  const OnSubmit = async (values: CraftsTypes.Info) => {
    values.deviceType = 0;
    if (values.id) {
      const response = await CraftsInfoAPI.Update(values);
      if (response.statusCode === 200) {
        message.success('修改成功');
        actionRef.current?.reload();
        setIsModalOpen(false);
      } else {
        message.error(response.errors || '修改失败');
      }
    } else {
      const response = await CraftsInfoAPI.Add(values);
      if (response.statusCode === 200) {
        message.success('添加成功');
        actionRef.current?.reload();
        setIsModalOpen(false);
      } else {
        message.error(response.errors || '添加失败');
      }
    }
  }

  //表单名
  const columns: ProColumns<CraftsTypes.Info>[] = [
    {
      dataIndex: 'id',
      align: 'center',
      hideInTable:true,
      // columns: () => {
      //   return  []
      // },
      readonly:true,
      search:false
    },
    {
      title: '设备产品',
      dataIndex: 'deviceProductId',
      align: 'center',
      valueType:'select',
      request:async ()=>{
      const data:MyResponse.Content =await  DeviceProductAPI.SelectList()
          const chan:any[] = data.data;
          chan.map(item=>(
            item.label = item.value,
            item.value = item.key
          ))
         return chan;
      },
    },
    {
      title: '工艺名称',
      dataIndex: 'name',
      align: 'center',
      search:false
    },
    {
      title: '工艺描述',
      dataIndex: 'description',
      align: 'center',
      hideInSearch: true
    },
    {
      title: '操作',
      align: 'center',

      valueType: 'option',

      key: 'option',
      render: (_, record) => [
        <Space key={+new Date() + Math.random()} size="middle">
          <Button
            key={+new Date() + Math.random()}
            type='primary' ghost
            onClick={async () => {
              setIsModalOpen(true)
              const copyFormData = JSON.parse(JSON.stringify(record));
              typeForm.setFieldsValue(copyFormData);
            }}
          >
            编辑
          </Button>
          <Popconfirm
            key={+new Date() + Math.random()}
            title="确定要删除此条数据吗？"
            onConfirm={() => {
              const delData: CraftsTypes.Info = {
                id: record.id,
                name: '',
              };
              CraftsInfoAPI.Del(delData).then((r) => {
                if (r.statusCode === 200) {
                  message.success(r.statusCode === 200 ? '删除成功' : r.message);
                  actionRef.current?.reload();
                }
              });
            }}
            onCancel={() => {
              message.info('已取消删除');
            }}
            okText="确认"
            cancelText="关闭"
          >
            <Button type='primary' danger ghost>删除</Button>
          </Popconfirm>
        </Space>
      ],
    },
  ];
  const editcolumns: ProColumns<RecipeMaterialTypes.Info>[] = [
    {
      title: '步骤名称',
      dataIndex: 'materialId',
      valueType: 'select',
      ellipsis: true,
      request: async () => {
        const res: MyResponse.Content = await MaterialsInfoAPI.List();
        const myData: any[] = [];
        if (res.statusCode === 200) {
          setSelectMateriallist(res.data)
          res.data.map((item: MaterialsTypes.Info) => (
            myData.push({
              label: `${item.name}${item.unit}`,
              value: item.id,
            })
          ))
        }
        return myData;
      },
      formItemProps: () => {
        return {
          rules: [{ required: true, message: '此项为必填项' }]
        };
      },
    },
    {
      title: '功能参数',
      dataIndex: 'materialId',
    },
    {
      title: '',
      dataIndex: 'weight',
      valueType: 'text',
      ellipsis: true,
      formItemProps: () => {
        return {
          rules: [{ required: true, message: '此项为必填项' }],
        };
      },
    },
    {
      title: '操作',
      valueType: 'option',
      render: (_, row) => [
        <Button
          type='primary' ghost
          key={+new Date() + Math.random()}
          onClick={() => {
            console.log(row);
            editactionRef.current?.startEditable(row.id);
          }}
        >
          编辑原料
        </Button>,

      ],
    },
  ];
  return (
    <>
      {
       /*
       * 工艺信息
       */}
      <Row wrap={false} gutter={[10, 10]}>
        <Col flex={0.1}>
          <ProTable<CraftsTypes.Info>
            columns={columns}
            actionRef={actionRef}
            className='box'
            cardBordered
            dateFormatter="string"
            headerTitle='工艺列表'
            rowClassName={(_, index) => (index === rowIndex ? 'rowBgColor' : '')}
            onRow={(record, index) => {
              return {
                onClick: () => {
                  if (record.id) {
                    setRowIndex(index)
                    setStepparams({ craftId: record.id })
                    setStepTitle(`[${record.name}]步骤列表`)
                  }
                },
              };
            }}
            request={async (params = {}) => {


              const jsonData: CraftsTypes.Page = {
                pageIndex: params.current || 1,
                pageSize: params.pageSize || 10,
                name: params.name || '',
                deviceType: 0,
              };
              const response = await CraftsInfoAPI.PagedList(jsonData);
              if (response.statusCode === 200) {
                return {
                  data: response.data.items,
                  success: true,
                  total: response.data.total,
                };
              } else {
                return {
                  data: [],
                  success: false,
                  total: 0,
                };
              }
            }}
            rowKey="id"
            pagination={{
              pageSize: 10,
            }}

            toolBarRender={() => [
              <Button
                key={+new Date() + Math.random()}
                type="primary"
                onClick={() => {
                  typeForm.resetFields();
                  setIsModalOpen(true);
                }}
              >
                添加工艺
              </Button>,
            ]}
          />
        </Col>
        <Col flex={4}>
          <DragSortTable<CraftsTypes.Info>
             toolBarRender={() => [
              <Button
                key={+new Date() + Math.random()}
                type="primary"
                onClick={() => {
                  setIsSetpModalOpen(true);
                }}
              >
                添加步骤
              </Button>,
            ]}
            actionRef={sortActionRef}
            headerTitle="步骤"
            columns={[
              {
                title: '步骤',
                dataIndex: 'step',
                align: 'center',
                hideInSearch: true,
                render: (dom, rowData, index) => {
                  return (
                    <span className="customRender">{`${index+1}`}</span>
                  );
                },
              },
              {
                title: '步骤描述',
                dataIndex: 'describe',
                align: 'center',
                hideInSearch: true
              },
              {
                title: '操作',
                align: 'center',

                valueType: 'option',

                key: 'option',
                render: (_, record) => [
                  <Space key={+new Date() + Math.random()} size="middle">
                    <Button
                      key={+new Date() + Math.random()}
                      type='primary' ghost
                      onClick={async () => {
                        setIsModalOpen(true)
                        const copyFormData = JSON.parse(JSON.stringify(record));
                        typeForm.setFieldsValue(copyFormData);
                      }}
                    >
                      编辑
                    </Button>
                    <Button
                      key={+new Date() + Math.random()}
                      type='primary' ghost
                      onClick={async () => {
                        setIsSchemaModalOpen(true)
                        const copyFormData = JSON.parse(JSON.stringify(record));
                        typeForm.setFieldsValue(copyFormData);
                      }}
                    >
                      配置设备参数
                    </Button>
                    <Popconfirm
                      key={+new Date() + Math.random()}
                      title="确定要删除此条数据吗？"
                      onConfirm={() => {
                        const delData: CraftsTypes.Info = {
                          id: record.id,
                          name: '',
                        };
                        CraftsInfoAPI.Del(delData).then((r) => {
                          if (r.statusCode === 200) {
                            message.success(r.statusCode === 200 ? '删除成功' : r.message);
                            actionRef.current?.reload();
                          }
                        });
                      }}
                      onCancel={() => {
                        message.info('已取消删除');
                      }}
                      okText="确认"
                      cancelText="关闭"
                    >
                      <Button type='primary' danger ghost>删除</Button>
                    </Popconfirm>
                  </Space>
                ],
              },
            ]}
            rowKey="step"
            search={false}
            pagination={false}
            params ={stepparams}
            request={async (params = {}) => {
              const jsonData: CraftsTypes.Pztj_CraftStepsPageInput = {
                pageIndex: params.current || 1,
                pageSize: params.pageSize || 10,
                craftId: params.craftId,
              };
              const response = await CraftsInfoAPI.craftsStepPage(jsonData);
              if (response.statusCode === 200) {
                return {
                  data: response.data.items,
                  success: true,
                  total: response.data.total,
                };
              } else {
                return {
                  data: [],
                  success: false,
                  total: 0,
                };
              }
            }}
            dragSortKey="step"
            onDragSortEnd={(newDataSource: any[]) => {
             
              // 模拟将排序后数据发送到服务器的场景
              // remoteData = newDataSource;
              // 请求成功之后刷新列表
              newDataSource.map((item,index)=>{
                 item.step = index+1;
              })
              console.log('排序后的数据', newDataSource);
              CraftsInfoAPI.BatchUpdateStep(newDataSource).then((res:MyResponse.Content)=>{
                if (res.data) {
                  sortActionRef.current?.reload();
                  message.success('修改列表排序成功');
                }
              });
              
            }}
          />
        </Col>
      </Row>
      {
       /*
       * 新增工艺信息
       */}
      <Modal
        key={+new Date() + Math.random()}
        width={800}
        
        title={<Tag color="#cd201f">新增信息</Tag>}
        open={isModalOpen}
        onCancel={() => {
          setIsModalOpen(false);
        }}
        footer={false}
      >
        <BetaSchemaForm<CraftsTypes.craftsInfoOutput>
        
        onFinish={async (values) => {
          console.log(values);
        }}
        form={typeForm}
        columns={columns}
      />
        
      </Modal>
      <Modal
      destroyOnClose
       key={+new Date() + Math.random()}
       width={800}
       open={isSetpModalOpen}
       onCancel={() => {
         setIsSetpModalOpen(false);
       }}
       footer={false}
        title={<Tag color="#cd201f"> 添加步骤 </Tag>}
      >
        <ProForm  onFinish={async (value:CraftsTypes.Pztj_CraftStepsAddInput) => {
          value.craftId = stepparams.craftId;
          console.log(value);
          CraftsInfoAPI.StepAdd(value).then((res: MyResponse.Content)=>{
              if (res.data) {
                message.success('提交成功');
                setIsSetpModalOpen(false);
                sortActionRef.current?.reload()
              }else{
                message.success(res.errors);
              }
          })
       
      }}>
         <Form.Item label="步骤Id" name="id" hidden>
           <Input></Input>
          </Form.Item>
          <Form.Item>
           <div>将自动生成步骤序号</div>
          </Form.Item>
          <Form.Item label="步骤说明" name="describe">
          <Input></Input>
          </Form.Item>
        </ProForm>
      </Modal>


      {
       /*
       * 配置设备参数弹框
       */}
      <Modal
        key={+new Date() + Math.random()}
        width={800}
        title={<Tag color="#cd201f"> 配置设备参数信息</Tag>}
        open={isSchemaModalOpen}
        onCancel={() => {
          setIsSchemaModalOpen(false);
        }}
        footer={false}
      >
        <Form

          name="basic1"
          id="myForm1111"
          labelCol={{ span: 4 }}
          wrapperCol={{ span: 12 }}
          onFinish={OnSubmit}
          autoComplete="off"
        >
          <Form.Item label="id" name="id" hidden>
            <Input />
          </Form.Item>
          <Form.Item
            label="设备信息"
            name="name"
            rules={[{ required: true, message: '此项必填！' }]}
          >
            <Select onChange={(value, index) => {
              const b = [];
              let num = Math.floor(Math.random() * 10);
              for (let i = 0; i < num + 1; i++) {
                const element = {
                  title: '属性' + { i },
                  dataIndex: 'state1' + { i },
                  valueType: 'text',
                  width: 'md',
                  colProps: {
                    xs: 24,
                    md: 12,
                  },
                }
                b.push(element)
              }

              setDeviceParm(b);

            }} placeholder="下拉选择设备">
              {
                devices.map((item: MySelectType.Select) => {
                  return <Select.Option value={item.key} key={item.key}>
                    <span>{item.value}</span>
                  </Select.Option>
                })
              }
            </Select>
          </Form.Item>


        </Form>
        <Card>
          <BetaSchemaForm<any>
            trigger={<a>点击我</a>}


            rowProps={{
              gutter: [16, 16],
            }}
            colProps={{
              span: 12,
            }}
            grid={true}
            onFinish={async (values) => {
              console.log(values);
            }}
            columns={deviceParm}
          />
        </Card>
      </Modal>
    </>
  )
}

export default Index;
